<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>ReverseUtils xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/cpp/reverse/reverse/ReverseUtils.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2016 CEA LIST</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials are</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * made available under the terms of the Eclipse Public License v1.0 which</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> *   Shuai Li (CEA LIST) &lt;shuai.li@cea.fr&gt; - Initial API and implementation</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *   Van Cam Pham (CEA LIST) &lt;vancam.pham@cea.fr&gt; - Reverse implementation</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.cpp.reverse.reverse;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> com.google.common.base.Objects;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> com.google.common.collect.Iterables;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> java.util.function.Consumer;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> java.util.regex.Matcher;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> java.util.regex.Pattern;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.dom.ast.ExpansionOverlapsBoundaryException;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.dom.ast.IASTArrayModifier;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.dom.ast.IASTDeclSpecifier;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.dom.ast.IASTDeclarator;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.dom.ast.IASTEqualsInitializer;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.dom.ast.IASTExpression;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.dom.ast.IASTInitializer;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.dom.ast.IASTInitializerClause;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.dom.ast.IASTPointerOperator;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.dom.ast.cpp.ICPPASTArrayDeclarator;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.dom.ast.cpp.ICPPASTReferenceOperator;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.model.CoreModel;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.model.CoreModelUtil;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.model.ICContainer;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.model.ICElement;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.model.ICProject;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.model.IEnumeration;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.model.IInclude;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.model.INamespace;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.model.IParent;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.model.IStructure;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.model.IStructureDeclaration;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.model.ITranslationUnit;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.model.ITypeDef;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.parser.IToken;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.resources.IFile;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.resources.IProject;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IPath;
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.UniqueEList;
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EObject;
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.Array;
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.Const;
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.External;
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.Friend;
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.Inline;
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.Mutable;
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.Ptr;
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.Ref;
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.Variadic;
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.Virtual;
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.Volatile;
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.StereotypeUtil;
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.OpaqueExpression;
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Parameter;
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Stereotype;
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Type;
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TypedElement;
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.UMLPackage;
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ValueSpecification;
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.util.UMLUtil;
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.xbase.lib.Conversions;
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.xbase.lib.Exceptions;
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.xbase.lib.Functions.Function1;
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.xbase.lib.IterableExtensions;
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  <em class="jxr_javadoccomment"> * Utility methods for the reverse</em>
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  @SuppressWarnings(<span class="jxr_string">"all"</span>)
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/reverse/reverse/ReverseUtils.html">ReverseUtils</a> {
<a class="jxr_linenumber" name="L84" href="#L84">84</a>    <strong class="jxr_keyword">public</strong> enum <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/reverse/reverse/ReverseUtils.html">StereotypeType</a> {
<a class="jxr_linenumber" name="L85" href="#L85">85</a>      CONST,
<a class="jxr_linenumber" name="L86" href="#L86">86</a>      
<a class="jxr_linenumber" name="L87" href="#L87">87</a>      VOLATILE,
<a class="jxr_linenumber" name="L88" href="#L88">88</a>      
<a class="jxr_linenumber" name="L89" href="#L89">89</a>      ARRAY,
<a class="jxr_linenumber" name="L90" href="#L90">90</a>      
<a class="jxr_linenumber" name="L91" href="#L91">91</a>      POINTER,
<a class="jxr_linenumber" name="L92" href="#L92">92</a>      
<a class="jxr_linenumber" name="L93" href="#L93">93</a>      REFERENCE,
<a class="jxr_linenumber" name="L94" href="#L94">94</a>      
<a class="jxr_linenumber" name="L95" href="#L95">95</a>      EXTERNAL,
<a class="jxr_linenumber" name="L96" href="#L96">96</a>      
<a class="jxr_linenumber" name="L97" href="#L97">97</a>      FRIENDLINE,
<a class="jxr_linenumber" name="L98" href="#L98">98</a>      
<a class="jxr_linenumber" name="L99" href="#L99">99</a>      VIRTUAL,
<a class="jxr_linenumber" name="L100" href="#L100">100</a>     
<a class="jxr_linenumber" name="L101" href="#L101">101</a>     INLINE,
<a class="jxr_linenumber" name="L102" href="#L102">102</a>     
<a class="jxr_linenumber" name="L103" href="#L103">103</a>     CREATE,
<a class="jxr_linenumber" name="L104" href="#L104">104</a>     
<a class="jxr_linenumber" name="L105" href="#L105">105</a>     DESTROY,
<a class="jxr_linenumber" name="L106" href="#L106">106</a>     
<a class="jxr_linenumber" name="L107" href="#L107">107</a>     MUTABLE,
<a class="jxr_linenumber" name="L108" href="#L108">108</a>     
<a class="jxr_linenumber" name="L109" href="#L109">109</a>     VARIADIC;
<a class="jxr_linenumber" name="L110" href="#L110">110</a>   }
<a class="jxr_linenumber" name="L111" href="#L111">111</a>   
<a class="jxr_linenumber" name="L112" href="#L112">112</a>   <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/reverse/reverse/ReverseUtils.html">ReverseUtils</a> instance;
<a class="jxr_linenumber" name="L113" href="#L113">113</a>   
<a class="jxr_linenumber" name="L114" href="#L114">114</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/reverse/reverse/ReverseUtils.html">ReverseUtils</a> getInstance() {
<a class="jxr_linenumber" name="L115" href="#L115">115</a>     <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/reverse/reverse/ReverseUtils.html">ReverseUtils</a> _xblockexpression = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L116" href="#L116">116</a>     {
<a class="jxr_linenumber" name="L117" href="#L117">117</a>       <strong class="jxr_keyword">boolean</strong> _equals = Objects.equal(ReverseUtils.instance, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L118" href="#L118">118</a>       <strong class="jxr_keyword">if</strong> (_equals) {
<a class="jxr_linenumber" name="L119" href="#L119">119</a>         <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/reverse/reverse/ReverseUtils.html">ReverseUtils</a> _reverseUtils = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/reverse/reverse/ReverseUtils.html">ReverseUtils</a>();
<a class="jxr_linenumber" name="L120" href="#L120">120</a>         ReverseUtils.instance = _reverseUtils;
<a class="jxr_linenumber" name="L121" href="#L121">121</a>       }
<a class="jxr_linenumber" name="L122" href="#L122">122</a>       _xblockexpression = ReverseUtils.instance;
<a class="jxr_linenumber" name="L123" href="#L123">123</a>     }
<a class="jxr_linenumber" name="L124" href="#L124">124</a>     <strong class="jxr_keyword">return</strong> _xblockexpression;
<a class="jxr_linenumber" name="L125" href="#L125">125</a>   }
<a class="jxr_linenumber" name="L126" href="#L126">126</a>   
<a class="jxr_linenumber" name="L127" href="#L127">127</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> analyzeDeclaration(<strong class="jxr_keyword">final</strong> List&lt;IASTDeclarator&gt; declarators, <strong class="jxr_keyword">final</strong> Type type, <strong class="jxr_keyword">final</strong> TypedElement typedElement, <strong class="jxr_keyword">final</strong> String langID) {
<a class="jxr_linenumber" name="L128" href="#L128">128</a>     <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">final</strong> IASTDeclarator declarator : declarators) {
<a class="jxr_linenumber" name="L129" href="#L129">129</a>       <strong class="jxr_keyword">this</strong>.analyzeDeclaration(declarator, type, typedElement, langID);
<a class="jxr_linenumber" name="L130" href="#L130">130</a>     }
<a class="jxr_linenumber" name="L131" href="#L131">131</a>   }
<a class="jxr_linenumber" name="L132" href="#L132">132</a>   
<a class="jxr_linenumber" name="L133" href="#L133">133</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> analyzeDeclaration(<strong class="jxr_keyword">final</strong> IASTDeclarator declarator, <strong class="jxr_keyword">final</strong> Type type, <strong class="jxr_keyword">final</strong> TypedElement typedElement, <strong class="jxr_keyword">final</strong> String langID) {
<a class="jxr_linenumber" name="L134" href="#L134">134</a>     <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L135" href="#L135">135</a>       <strong class="jxr_keyword">if</strong> ((declarator instanceof ICPPASTArrayDeclarator)) {
<a class="jxr_linenumber" name="L136" href="#L136">136</a>         ICPPASTArrayDeclarator arrayDeclarator = ((ICPPASTArrayDeclarator) declarator);
<a class="jxr_linenumber" name="L137" href="#L137">137</a>         IASTArrayModifier[] arrays = arrayDeclarator.getArrayModifiers();
<a class="jxr_linenumber" name="L138" href="#L138">138</a>         <strong class="jxr_keyword">final</strong> IASTArrayModifier[] _converted_arrays = (IASTArrayModifier[])arrays;
<a class="jxr_linenumber" name="L139" href="#L139">139</a>         <strong class="jxr_keyword">int</strong> _size = ((List&lt;IASTArrayModifier&gt;)Conversions.doWrapArray(_converted_arrays)).size();
<a class="jxr_linenumber" name="L140" href="#L140">140</a>         <strong class="jxr_keyword">boolean</strong> _greaterThan = (_size &gt; 0);
<a class="jxr_linenumber" name="L141" href="#L141">141</a>         <strong class="jxr_keyword">if</strong> (_greaterThan) {
<a class="jxr_linenumber" name="L142" href="#L142">142</a>           <strong class="jxr_keyword">boolean</strong> _isApplied = StereotypeUtil.isApplied(typedElement, Array.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L143" href="#L143">143</a>           <strong class="jxr_keyword">if</strong> (_isApplied) {
<a class="jxr_linenumber" name="L144" href="#L144">144</a>             StereotypeUtil.unapply(typedElement, Array.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L145" href="#L145">145</a>           }
<a class="jxr_linenumber" name="L146" href="#L146">146</a>           <strong class="jxr_keyword">this</strong>.applyStereotype(typedElement, <strong class="jxr_keyword">true</strong>, ReverseUtils.StereotypeType.ARRAY, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L147" href="#L147">147</a>           <strong class="jxr_keyword">final</strong> IASTArrayModifier[] _converted_arrays_1 = (IASTArrayModifier[])arrays;
<a class="jxr_linenumber" name="L148" href="#L148">148</a>           <strong class="jxr_keyword">final</strong> Consumer&lt;IASTArrayModifier&gt; _function = <strong class="jxr_keyword">new</strong> Consumer&lt;IASTArrayModifier&gt;() {
<a class="jxr_linenumber" name="L149" href="#L149">149</a>             @Override
<a class="jxr_linenumber" name="L150" href="#L150">150</a>             <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> accept(<strong class="jxr_keyword">final</strong> IASTArrayModifier it) {
<a class="jxr_linenumber" name="L151" href="#L151">151</a>               IASTExpression expr = it.getConstantExpression();
<a class="jxr_linenumber" name="L152" href="#L152">152</a>               <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(expr, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L153" href="#L153">153</a>               <strong class="jxr_keyword">if</strong> (_notEquals) {
<a class="jxr_linenumber" name="L154" href="#L154">154</a>                 Array _stereotypeApplication = UMLUtil.&lt;Array&gt;getStereotypeApplication(typedElement, Array.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L155" href="#L155">155</a>                 String definition = _stereotypeApplication.getDefinition();
<a class="jxr_linenumber" name="L156" href="#L156">156</a>                 Array _stereotypeApplication_1 = UMLUtil.&lt;Array&gt;getStereotypeApplication(typedElement, Array.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L157" href="#L157">157</a>                 String _string = expr.toString();
<a class="jxr_linenumber" name="L158" href="#L158">158</a>                 String _plus = ((definition + <span class="jxr_string">"["</span>) + _string);
<a class="jxr_linenumber" name="L159" href="#L159">159</a>                 String _plus_1 = (_plus + <span class="jxr_string">"]"</span>);
<a class="jxr_linenumber" name="L160" href="#L160">160</a>                 _stereotypeApplication_1.setDefinition(_plus_1);
<a class="jxr_linenumber" name="L161" href="#L161">161</a>               }
<a class="jxr_linenumber" name="L162" href="#L162">162</a>             }
<a class="jxr_linenumber" name="L163" href="#L163">163</a>           };
<a class="jxr_linenumber" name="L164" href="#L164">164</a>           ((List&lt;IASTArrayModifier&gt;)Conversions.doWrapArray(_converted_arrays_1)).forEach(_function);
<a class="jxr_linenumber" name="L165" href="#L165">165</a>         }
<a class="jxr_linenumber" name="L166" href="#L166">166</a>       }
<a class="jxr_linenumber" name="L167" href="#L167">167</a>       IASTPointerOperator[] _pointerOperators = declarator.getPointerOperators();
<a class="jxr_linenumber" name="L168" href="#L168">168</a>       <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(_pointerOperators, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L169" href="#L169">169</a>       <strong class="jxr_keyword">if</strong> (_notEquals) {
<a class="jxr_linenumber" name="L170" href="#L170">170</a>         <strong class="jxr_keyword">boolean</strong> _isApplied_1 = StereotypeUtil.isApplied(typedElement, Ptr.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L171" href="#L171">171</a>         <strong class="jxr_keyword">if</strong> (_isApplied_1) {
<a class="jxr_linenumber" name="L172" href="#L172">172</a>           Ptr _stereotypeApplication = UMLUtil.&lt;Ptr&gt;getStereotypeApplication(typedElement, Ptr.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L173" href="#L173">173</a>           _stereotypeApplication.setDeclaration(<span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L174" href="#L174">174</a>         }
<a class="jxr_linenumber" name="L175" href="#L175">175</a>         IASTPointerOperator[] _pointerOperators_1 = declarator.getPointerOperators();
<a class="jxr_linenumber" name="L176" href="#L176">176</a>         <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">final</strong> IASTPointerOperator pointerOperator : _pointerOperators_1) {
<a class="jxr_linenumber" name="L177" href="#L177">177</a>           <strong class="jxr_keyword">if</strong> ((pointerOperator instanceof ICPPASTReferenceOperator)) {
<a class="jxr_linenumber" name="L178" href="#L178">178</a>             ICPPASTReferenceOperator reference = ((ICPPASTReferenceOperator) pointerOperator);
<a class="jxr_linenumber" name="L179" href="#L179">179</a>             <strong class="jxr_keyword">boolean</strong> _isApplied_2 = StereotypeUtil.isApplied(typedElement, Ref.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L180" href="#L180">180</a>             <strong class="jxr_keyword">boolean</strong> _not = (!_isApplied_2);
<a class="jxr_linenumber" name="L181" href="#L181">181</a>             <strong class="jxr_keyword">if</strong> (_not) {
<a class="jxr_linenumber" name="L182" href="#L182">182</a>               IToken _syntax = reference.getSyntax();
<a class="jxr_linenumber" name="L183" href="#L183">183</a>               String _string = _syntax.toString();
<a class="jxr_linenumber" name="L184" href="#L184">184</a>               <strong class="jxr_keyword">this</strong>.applyStereotype(typedElement, <strong class="jxr_keyword">true</strong>, ReverseUtils.StereotypeType.REFERENCE, _string);
<a class="jxr_linenumber" name="L185" href="#L185">185</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L186" href="#L186">186</a>               Ref _stereotypeApplication_1 = UMLUtil.&lt;Ref&gt;getStereotypeApplication(typedElement, Ref.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L187" href="#L187">187</a>               String value = _stereotypeApplication_1.getDeclaration();
<a class="jxr_linenumber" name="L188" href="#L188">188</a>               Ref _stereotypeApplication_2 = UMLUtil.&lt;Ref&gt;getStereotypeApplication(typedElement, Ref.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L189" href="#L189">189</a>               IToken _syntax_1 = reference.getSyntax();
<a class="jxr_linenumber" name="L190" href="#L190">190</a>               String _string_1 = _syntax_1.toString();
<a class="jxr_linenumber" name="L191" href="#L191">191</a>               String _plus = (value + _string_1);
<a class="jxr_linenumber" name="L192" href="#L192">192</a>               _stereotypeApplication_2.setDeclaration(_plus);
<a class="jxr_linenumber" name="L193" href="#L193">193</a>             }
<a class="jxr_linenumber" name="L194" href="#L194">194</a>           } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L195" href="#L195">195</a>             <strong class="jxr_keyword">if</strong> ((pointerOperator instanceof IASTPointerOperator)) {
<a class="jxr_linenumber" name="L196" href="#L196">196</a>               IASTPointerOperator pointer = ((IASTPointerOperator) pointerOperator);
<a class="jxr_linenumber" name="L197" href="#L197">197</a>               <strong class="jxr_keyword">boolean</strong> _isApplied_3 = StereotypeUtil.isApplied(typedElement, Ptr.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L198" href="#L198">198</a>               <strong class="jxr_keyword">boolean</strong> _not_1 = (!_isApplied_3);
<a class="jxr_linenumber" name="L199" href="#L199">199</a>               <strong class="jxr_keyword">if</strong> (_not_1) {
<a class="jxr_linenumber" name="L200" href="#L200">200</a>                 IToken _syntax_2 = pointer.getSyntax();
<a class="jxr_linenumber" name="L201" href="#L201">201</a>                 String _string_2 = _syntax_2.toString();
<a class="jxr_linenumber" name="L202" href="#L202">202</a>                 <strong class="jxr_keyword">this</strong>.applyStereotype(typedElement, <strong class="jxr_keyword">true</strong>, ReverseUtils.StereotypeType.POINTER, _string_2);
<a class="jxr_linenumber" name="L203" href="#L203">203</a>               } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L204" href="#L204">204</a>                 Ptr _stereotypeApplication_3 = UMLUtil.&lt;Ptr&gt;getStereotypeApplication(typedElement, Ptr.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L205" href="#L205">205</a>                 String value_1 = _stereotypeApplication_3.getDeclaration();
<a class="jxr_linenumber" name="L206" href="#L206">206</a>                 Ptr _stereotypeApplication_4 = UMLUtil.&lt;Ptr&gt;getStereotypeApplication(typedElement, Ptr.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L207" href="#L207">207</a>                 IToken _syntax_3 = pointer.getSyntax();
<a class="jxr_linenumber" name="L208" href="#L208">208</a>                 String _string_3 = _syntax_3.toString();
<a class="jxr_linenumber" name="L209" href="#L209">209</a>                 String _plus_1 = (value_1 + _string_3);
<a class="jxr_linenumber" name="L210" href="#L210">210</a>                 _stereotypeApplication_4.setDeclaration(_plus_1);
<a class="jxr_linenumber" name="L211" href="#L211">211</a>               }
<a class="jxr_linenumber" name="L212" href="#L212">212</a>             }
<a class="jxr_linenumber" name="L213" href="#L213">213</a>           }
<a class="jxr_linenumber" name="L214" href="#L214">214</a>         }
<a class="jxr_linenumber" name="L215" href="#L215">215</a>         <strong class="jxr_keyword">boolean</strong> _isApplied_4 = StereotypeUtil.isApplied(typedElement, Ptr.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L216" href="#L216">216</a>         <strong class="jxr_keyword">if</strong> (_isApplied_4) {
<a class="jxr_linenumber" name="L217" href="#L217">217</a>           Ptr _stereotypeApplication_5 = UMLUtil.&lt;Ptr&gt;getStereotypeApplication(typedElement, Ptr.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L218" href="#L218">218</a>           String value_2 = _stereotypeApplication_5.getDeclaration();
<a class="jxr_linenumber" name="L219" href="#L219">219</a>           <strong class="jxr_keyword">boolean</strong> _equals = Objects.equal(value_2, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L220" href="#L220">220</a>           <strong class="jxr_keyword">if</strong> (_equals) {
<a class="jxr_linenumber" name="L221" href="#L221">221</a>             value_2 = <span class="jxr_string">"*"</span>;
<a class="jxr_linenumber" name="L222" href="#L222">222</a>           }
<a class="jxr_linenumber" name="L223" href="#L223">223</a>           Pattern pattern = Pattern.compile(<span class="jxr_string">"(&#92;&#92;*)([&#92;&#92;s]*)(const)"</span>);
<a class="jxr_linenumber" name="L224" href="#L224">224</a>           String _rawSignature = declarator.getRawSignature();
<a class="jxr_linenumber" name="L225" href="#L225">225</a>           Matcher matcher = pattern.matcher(_rawSignature);
<a class="jxr_linenumber" name="L226" href="#L226">226</a>           <strong class="jxr_keyword">boolean</strong> _find = matcher.find();
<a class="jxr_linenumber" name="L227" href="#L227">227</a>           <strong class="jxr_keyword">if</strong> (_find) {
<a class="jxr_linenumber" name="L228" href="#L228">228</a>             String _value = value_2;
<a class="jxr_linenumber" name="L229" href="#L229">229</a>             value_2 = (_value + <span class="jxr_string">" const"</span>);
<a class="jxr_linenumber" name="L230" href="#L230">230</a>             Ptr _stereotypeApplication_6 = UMLUtil.&lt;Ptr&gt;getStereotypeApplication(typedElement, Ptr.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L231" href="#L231">231</a>             _stereotypeApplication_6.setDeclaration(value_2);
<a class="jxr_linenumber" name="L232" href="#L232">232</a>           }
<a class="jxr_linenumber" name="L233" href="#L233">233</a>           String _trim = value_2.trim();
<a class="jxr_linenumber" name="L234" href="#L234">234</a>           <strong class="jxr_keyword">boolean</strong> _equals_1 = _trim.equals(<span class="jxr_string">"*"</span>);
<a class="jxr_linenumber" name="L235" href="#L235">235</a>           <strong class="jxr_keyword">if</strong> (_equals_1) {
<a class="jxr_linenumber" name="L236" href="#L236">236</a>             Ptr _stereotypeApplication_7 = UMLUtil.&lt;Ptr&gt;getStereotypeApplication(typedElement, Ptr.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L237" href="#L237">237</a>             _stereotypeApplication_7.setDeclaration(<strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L238" href="#L238">238</a>           }
<a class="jxr_linenumber" name="L239" href="#L239">239</a>         }
<a class="jxr_linenumber" name="L240" href="#L240">240</a>         <strong class="jxr_keyword">boolean</strong> _isApplied_5 = StereotypeUtil.isApplied(typedElement, Ref.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L241" href="#L241">241</a>         <strong class="jxr_keyword">if</strong> (_isApplied_5) {
<a class="jxr_linenumber" name="L242" href="#L242">242</a>           Ref _stereotypeApplication_8 = UMLUtil.&lt;Ref&gt;getStereotypeApplication(typedElement, Ref.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L243" href="#L243">243</a>           String value_3 = _stereotypeApplication_8.getDeclaration();
<a class="jxr_linenumber" name="L244" href="#L244">244</a>           <strong class="jxr_keyword">boolean</strong> _and = false;
<a class="jxr_linenumber" name="L245" href="#L245">245</a>           <strong class="jxr_keyword">boolean</strong> _notEquals_1 = (!Objects.equal(value_3, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L246" href="#L246">246</a>           <strong class="jxr_keyword">if</strong> (!_notEquals_1) {
<a class="jxr_linenumber" name="L247" href="#L247">247</a>             _and = false;
<a class="jxr_linenumber" name="L248" href="#L248">248</a>           } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L249" href="#L249">249</a>             String _trim_1 = value_3.trim();
<a class="jxr_linenumber" name="L250" href="#L250">250</a>             <strong class="jxr_keyword">boolean</strong> _equals_2 = _trim_1.equals(<span class="jxr_string">"&amp;"</span>);
<a class="jxr_linenumber" name="L251" href="#L251">251</a>             _and = _equals_2;
<a class="jxr_linenumber" name="L252" href="#L252">252</a>           }
<a class="jxr_linenumber" name="L253" href="#L253">253</a>           <strong class="jxr_keyword">if</strong> (_and) {
<a class="jxr_linenumber" name="L254" href="#L254">254</a>             Ref _stereotypeApplication_9 = UMLUtil.&lt;Ref&gt;getStereotypeApplication(typedElement, Ref.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L255" href="#L255">255</a>             _stereotypeApplication_9.setDeclaration(<strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L256" href="#L256">256</a>           }
<a class="jxr_linenumber" name="L257" href="#L257">257</a>         }
<a class="jxr_linenumber" name="L258" href="#L258">258</a>       }
<a class="jxr_linenumber" name="L259" href="#L259">259</a>       IASTInitializer initilizer = declarator.getInitializer();
<a class="jxr_linenumber" name="L260" href="#L260">260</a>       EList&lt;Element&gt; _ownedElements = typedElement.getOwnedElements();
<a class="jxr_linenumber" name="L261" href="#L261">261</a>       Iterable&lt;ValueSpecification&gt; _filter = Iterables.&lt;ValueSpecification&gt;filter(_ownedElements, ValueSpecification.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L262" href="#L262">262</a>       <strong class="jxr_keyword">final</strong> Function1&lt;ValueSpecification, Boolean&gt; _function_1 = <strong class="jxr_keyword">new</strong> Function1&lt;ValueSpecification, Boolean&gt;() {
<a class="jxr_linenumber" name="L263" href="#L263">263</a>         @Override
<a class="jxr_linenumber" name="L264" href="#L264">264</a>         <strong class="jxr_keyword">public</strong> Boolean apply(<strong class="jxr_keyword">final</strong> ValueSpecification it) {
<a class="jxr_linenumber" name="L265" href="#L265">265</a>           String _name = it.getName();
<a class="jxr_linenumber" name="L266" href="#L266">266</a>           <strong class="jxr_keyword">return</strong> Boolean.valueOf(_name.equals(<span class="jxr_string">"defaultValue"</span>));
<a class="jxr_linenumber" name="L267" href="#L267">267</a>         }
<a class="jxr_linenumber" name="L268" href="#L268">268</a>       };
<a class="jxr_linenumber" name="L269" href="#L269">269</a>       Iterable&lt;ValueSpecification&gt; _filter_1 = IterableExtensions.&lt;ValueSpecification&gt;filter(_filter, _function_1);
<a class="jxr_linenumber" name="L270" href="#L270">270</a>       ValueSpecification valueExisting = IterableExtensions.&lt;ValueSpecification&gt;head(_filter_1);
<a class="jxr_linenumber" name="L271" href="#L271">271</a>       <strong class="jxr_keyword">boolean</strong> _notEquals_2 = (!Objects.equal(valueExisting, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L272" href="#L272">272</a>       <strong class="jxr_keyword">if</strong> (_notEquals_2) {
<a class="jxr_linenumber" name="L273" href="#L273">273</a>         valueExisting.destroy();
<a class="jxr_linenumber" name="L274" href="#L274">274</a>       }
<a class="jxr_linenumber" name="L275" href="#L275">275</a>       <strong class="jxr_keyword">boolean</strong> _notEquals_3 = (!Objects.equal(initilizer, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L276" href="#L276">276</a>       <strong class="jxr_keyword">if</strong> (_notEquals_3) {
<a class="jxr_linenumber" name="L277" href="#L277">277</a>         ValueSpecification vs = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L278" href="#L278">278</a>         <strong class="jxr_keyword">if</strong> ((typedElement instanceof Property)) {
<a class="jxr_linenumber" name="L279" href="#L279">279</a>           Type _type = ((Property)typedElement).getType();
<a class="jxr_linenumber" name="L280" href="#L280">280</a>           ValueSpecification _createDefaultValue = ((Property) typedElement).createDefaultValue(<span class="jxr_string">"defaultValue"</span>, _type, 
<a class="jxr_linenumber" name="L281" href="#L281">281</a>             UMLPackage.Literals.OPAQUE_EXPRESSION);
<a class="jxr_linenumber" name="L282" href="#L282">282</a>           vs = _createDefaultValue;
<a class="jxr_linenumber" name="L283" href="#L283">283</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L284" href="#L284">284</a>           <strong class="jxr_keyword">if</strong> ((typedElement instanceof Parameter)) {
<a class="jxr_linenumber" name="L285" href="#L285">285</a>             Type _type_1 = ((Parameter)typedElement).getType();
<a class="jxr_linenumber" name="L286" href="#L286">286</a>             ValueSpecification _createDefaultValue_1 = ((Parameter) typedElement).createDefaultValue(<span class="jxr_string">"default"</span>, _type_1, 
<a class="jxr_linenumber" name="L287" href="#L287">287</a>               UMLPackage.Literals.OPAQUE_EXPRESSION);
<a class="jxr_linenumber" name="L288" href="#L288">288</a>             vs = _createDefaultValue_1;
<a class="jxr_linenumber" name="L289" href="#L289">289</a>           }
<a class="jxr_linenumber" name="L290" href="#L290">290</a>         }
<a class="jxr_linenumber" name="L291" href="#L291">291</a>         <strong class="jxr_keyword">boolean</strong> _equals_3 = Objects.equal(vs, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L292" href="#L292">292</a>         <strong class="jxr_keyword">if</strong> (_equals_3) {
<a class="jxr_linenumber" name="L293" href="#L293">293</a>           <strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="L294" href="#L294">294</a>         }
<a class="jxr_linenumber" name="L295" href="#L295">295</a>         OpaqueExpression oe = ((OpaqueExpression) vs);
<a class="jxr_linenumber" name="L296" href="#L296">296</a>         EList&lt;String&gt; _languages = oe.getLanguages();
<a class="jxr_linenumber" name="L297" href="#L297">297</a>         _languages.add(langID);
<a class="jxr_linenumber" name="L298" href="#L298">298</a>         <strong class="jxr_keyword">if</strong> ((initilizer instanceof IASTEqualsInitializer)) {
<a class="jxr_linenumber" name="L299" href="#L299">299</a>           IASTEqualsInitializer equalsInitialiser = ((IASTEqualsInitializer) initilizer);
<a class="jxr_linenumber" name="L300" href="#L300">300</a>           IASTInitializerClause clause = equalsInitialiser.getInitializerClause();
<a class="jxr_linenumber" name="L301" href="#L301">301</a>           <strong class="jxr_keyword">boolean</strong> _notEquals_4 = (!Objects.equal(clause, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L302" href="#L302">302</a>           <strong class="jxr_keyword">if</strong> (_notEquals_4) {
<a class="jxr_linenumber" name="L303" href="#L303">303</a>             EList&lt;String&gt; _bodies = oe.getBodies();
<a class="jxr_linenumber" name="L304" href="#L304">304</a>             String _rawSignature_1 = clause.getRawSignature();
<a class="jxr_linenumber" name="L305" href="#L305">305</a>             _bodies.add(_rawSignature_1);
<a class="jxr_linenumber" name="L306" href="#L306">306</a>           }
<a class="jxr_linenumber" name="L307" href="#L307">307</a>         }
<a class="jxr_linenumber" name="L308" href="#L308">308</a>       }
<a class="jxr_linenumber" name="L309" href="#L309">309</a>     } <strong class="jxr_keyword">catch</strong> (Throwable _e) {
<a class="jxr_linenumber" name="L310" href="#L310">310</a>       <strong class="jxr_keyword">throw</strong> Exceptions.sneakyThrow(_e);
<a class="jxr_linenumber" name="L311" href="#L311">311</a>     }
<a class="jxr_linenumber" name="L312" href="#L312">312</a>   }
<a class="jxr_linenumber" name="L313" href="#L313">313</a>   
<a class="jxr_linenumber" name="L314" href="#L314">314</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> applyStereotype(<strong class="jxr_keyword">final</strong> Element element, <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">boolean</strong> isApply, <strong class="jxr_keyword">final</strong> ReverseUtils.StereotypeType stType, <strong class="jxr_keyword">final</strong> String additional) {
<a class="jxr_linenumber" name="L315" href="#L315">315</a>     <strong class="jxr_keyword">if</strong> ((!isApply)) {
<a class="jxr_linenumber" name="L316" href="#L316">316</a>       <strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="L317" href="#L317">317</a>     }
<a class="jxr_linenumber" name="L318" href="#L318">318</a>     <strong class="jxr_keyword">if</strong> (stType != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L319" href="#L319">319</a>       <strong class="jxr_keyword">switch</strong> (stType) {
<a class="jxr_linenumber" name="L320" href="#L320">320</a>         <strong class="jxr_keyword">case</strong> CONST:
<a class="jxr_linenumber" name="L321" href="#L321">321</a>           StereotypeUtil.apply(element, Const.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L322" href="#L322">322</a>           <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L323" href="#L323">323</a>         <strong class="jxr_keyword">case</strong> VOLATILE:
<a class="jxr_linenumber" name="L324" href="#L324">324</a>           StereotypeUtil.apply(element, Volatile.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L325" href="#L325">325</a>           <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L326" href="#L326">326</a>         <strong class="jxr_keyword">case</strong> ARRAY:
<a class="jxr_linenumber" name="L327" href="#L327">327</a>           StereotypeUtil.apply(element, Array.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L328" href="#L328">328</a>           Array _stereotypeApplication = UMLUtil.&lt;Array&gt;getStereotypeApplication(element, Array.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L329" href="#L329">329</a>           _stereotypeApplication.setDefinition(additional);
<a class="jxr_linenumber" name="L330" href="#L330">330</a>           <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L331" href="#L331">331</a>         <strong class="jxr_keyword">case</strong> POINTER:
<a class="jxr_linenumber" name="L332" href="#L332">332</a>           StereotypeUtil.apply(element, Ptr.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L333" href="#L333">333</a>           Ptr _stereotypeApplication_1 = UMLUtil.&lt;Ptr&gt;getStereotypeApplication(element, Ptr.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L334" href="#L334">334</a>           _stereotypeApplication_1.setDeclaration(additional);
<a class="jxr_linenumber" name="L335" href="#L335">335</a>           <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L336" href="#L336">336</a>         <strong class="jxr_keyword">case</strong> REFERENCE:
<a class="jxr_linenumber" name="L337" href="#L337">337</a>           StereotypeUtil.apply(element, Ref.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L338" href="#L338">338</a>           Ref _stereotypeApplication_2 = UMLUtil.&lt;Ref&gt;getStereotypeApplication(element, Ref.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L339" href="#L339">339</a>           _stereotypeApplication_2.setDeclaration(additional);
<a class="jxr_linenumber" name="L340" href="#L340">340</a>           <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L341" href="#L341">341</a>         <strong class="jxr_keyword">case</strong> EXTERNAL:
<a class="jxr_linenumber" name="L342" href="#L342">342</a>           StereotypeUtil.apply(element, External.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L343" href="#L343">343</a>           <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L344" href="#L344">344</a>         <strong class="jxr_keyword">case</strong> FRIENDLINE:
<a class="jxr_linenumber" name="L345" href="#L345">345</a>           StereotypeUtil.apply(element, Friend.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L346" href="#L346">346</a>           <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L347" href="#L347">347</a>         <strong class="jxr_keyword">case</strong> VIRTUAL:
<a class="jxr_linenumber" name="L348" href="#L348">348</a>           StereotypeUtil.apply(element, Virtual.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L349" href="#L349">349</a>           <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L350" href="#L350">350</a>         <strong class="jxr_keyword">case</strong> INLINE:
<a class="jxr_linenumber" name="L351" href="#L351">351</a>           StereotypeUtil.apply(element, Inline.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L352" href="#L352">352</a>           <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L353" href="#L353">353</a>         <strong class="jxr_keyword">case</strong> CREATE:
<a class="jxr_linenumber" name="L354" href="#L354">354</a>           StereotypeUtil.apply(element, <span class="jxr_string">"StandardProfile::Create"</span>);
<a class="jxr_linenumber" name="L355" href="#L355">355</a>           <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L356" href="#L356">356</a>         <strong class="jxr_keyword">case</strong> DESTROY:
<a class="jxr_linenumber" name="L357" href="#L357">357</a>           StereotypeUtil.apply(element, <span class="jxr_string">"StandardProfile::Destroy"</span>);
<a class="jxr_linenumber" name="L358" href="#L358">358</a>           <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L359" href="#L359">359</a>         <strong class="jxr_keyword">case</strong> MUTABLE:
<a class="jxr_linenumber" name="L360" href="#L360">360</a>           StereotypeUtil.apply(element, Mutable.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L361" href="#L361">361</a>           <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L362" href="#L362">362</a>         <strong class="jxr_keyword">case</strong> VARIADIC:
<a class="jxr_linenumber" name="L363" href="#L363">363</a>           StereotypeUtil.apply(element, Variadic.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L364" href="#L364">364</a>           <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L365" href="#L365">365</a>         <strong class="jxr_keyword">default</strong>:
<a class="jxr_linenumber" name="L366" href="#L366">366</a>           <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L367" href="#L367">367</a>       }
<a class="jxr_linenumber" name="L368" href="#L368">368</a>     }
<a class="jxr_linenumber" name="L369" href="#L369">369</a>   }
<a class="jxr_linenumber" name="L370" href="#L370">370</a>   
<a class="jxr_linenumber" name="L371" href="#L371">371</a>   <strong class="jxr_keyword">public</strong> String getCppTypeName(<strong class="jxr_keyword">final</strong> IASTDeclSpecifier declarator) {
<a class="jxr_linenumber" name="L372" href="#L372">372</a>     String parameterTypeName = <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L373" href="#L373">373</a>     <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L374" href="#L374">374</a>       IToken token = declarator.getSyntax();
<a class="jxr_linenumber" name="L375" href="#L375">375</a>       <strong class="jxr_keyword">while</strong> ((!Objects.equal(token, <strong class="jxr_keyword">null</strong>))) {
<a class="jxr_linenumber" name="L376" href="#L376">376</a>         {
<a class="jxr_linenumber" name="L377" href="#L377">377</a>           String tokenStr = token.toString();
<a class="jxr_linenumber" name="L378" href="#L378">378</a>           <strong class="jxr_keyword">boolean</strong> _equals = tokenStr.equals(<span class="jxr_string">"*"</span>);
<a class="jxr_linenumber" name="L379" href="#L379">379</a>           <strong class="jxr_keyword">if</strong> (_equals) {
<a class="jxr_linenumber" name="L380" href="#L380">380</a>           } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L381" href="#L381">381</a>             <strong class="jxr_keyword">boolean</strong> _equals_1 = tokenStr.equals(<span class="jxr_string">"&amp;"</span>);
<a class="jxr_linenumber" name="L382" href="#L382">382</a>             <strong class="jxr_keyword">if</strong> (_equals_1) {
<a class="jxr_linenumber" name="L383" href="#L383">383</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L384" href="#L384">384</a>               <strong class="jxr_keyword">boolean</strong> _equals_2 = tokenStr.equals(<span class="jxr_string">"const"</span>);
<a class="jxr_linenumber" name="L385" href="#L385">385</a>               <strong class="jxr_keyword">if</strong> (_equals_2) {
<a class="jxr_linenumber" name="L386" href="#L386">386</a>               } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L387" href="#L387">387</a>                 <strong class="jxr_keyword">int</strong> _length = parameterTypeName.length();
<a class="jxr_linenumber" name="L388" href="#L388">388</a>                 <strong class="jxr_keyword">boolean</strong> _greaterThan = (_length &gt; 0);
<a class="jxr_linenumber" name="L389" href="#L389">389</a>                 <strong class="jxr_keyword">if</strong> (_greaterThan) {
<a class="jxr_linenumber" name="L390" href="#L390">390</a>                   String _parameterTypeName = parameterTypeName;
<a class="jxr_linenumber" name="L391" href="#L391">391</a>                   parameterTypeName = (_parameterTypeName + <span class="jxr_string">" "</span>);
<a class="jxr_linenumber" name="L392" href="#L392">392</a>                 }
<a class="jxr_linenumber" name="L393" href="#L393">393</a>                 String _parameterTypeName_1 = parameterTypeName;
<a class="jxr_linenumber" name="L394" href="#L394">394</a>                 parameterTypeName = (_parameterTypeName_1 + tokenStr);
<a class="jxr_linenumber" name="L395" href="#L395">395</a>               }
<a class="jxr_linenumber" name="L396" href="#L396">396</a>             }
<a class="jxr_linenumber" name="L397" href="#L397">397</a>           }
<a class="jxr_linenumber" name="L398" href="#L398">398</a>           IToken _next = token.getNext();
<a class="jxr_linenumber" name="L399" href="#L399">399</a>           token = _next;
<a class="jxr_linenumber" name="L400" href="#L400">400</a>         }
<a class="jxr_linenumber" name="L401" href="#L401">401</a>       }
<a class="jxr_linenumber" name="L402" href="#L402">402</a>     } <strong class="jxr_keyword">catch</strong> (<strong class="jxr_keyword">final</strong> Throwable _t) {
<a class="jxr_linenumber" name="L403" href="#L403">403</a>       <strong class="jxr_keyword">if</strong> (_t instanceof ExpansionOverlapsBoundaryException) {
<a class="jxr_linenumber" name="L404" href="#L404">404</a>         <strong class="jxr_keyword">final</strong> ExpansionOverlapsBoundaryException e = (ExpansionOverlapsBoundaryException)_t;
<a class="jxr_linenumber" name="L405" href="#L405">405</a>       } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L406" href="#L406">406</a>         <strong class="jxr_keyword">throw</strong> Exceptions.sneakyThrow(_t);
<a class="jxr_linenumber" name="L407" href="#L407">407</a>       }
<a class="jxr_linenumber" name="L408" href="#L408">408</a>     }
<a class="jxr_linenumber" name="L409" href="#L409">409</a>     <strong class="jxr_keyword">return</strong> parameterTypeName;
<a class="jxr_linenumber" name="L410" href="#L410">410</a>   }
<a class="jxr_linenumber" name="L411" href="#L411">411</a>   
<a class="jxr_linenumber" name="L412" href="#L412">412</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String getCppTypeName(<strong class="jxr_keyword">final</strong> String name) {
<a class="jxr_linenumber" name="L413" href="#L413">413</a>     String trimName = name.trim();
<a class="jxr_linenumber" name="L414" href="#L414">414</a>     String _replace = trimName.replace(<span class="jxr_string">"*"</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L415" href="#L415">415</a>     trimName = _replace;
<a class="jxr_linenumber" name="L416" href="#L416">416</a>     String _replace_1 = trimName.replace(<span class="jxr_string">"&amp;"</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L417" href="#L417">417</a>     trimName = _replace_1;
<a class="jxr_linenumber" name="L418" href="#L418">418</a>     String _replace_2 = trimName.replace(<span class="jxr_string">"["</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L419" href="#L419">419</a>     trimName = _replace_2;
<a class="jxr_linenumber" name="L420" href="#L420">420</a>     String _replace_3 = trimName.replace(<span class="jxr_string">"]"</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L421" href="#L421">421</a>     trimName = _replace_3;
<a class="jxr_linenumber" name="L422" href="#L422">422</a>     String _replace_4 = trimName.replace(<span class="jxr_string">"const "</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L423" href="#L423">423</a>     trimName = _replace_4;
<a class="jxr_linenumber" name="L424" href="#L424">424</a>     String _replace_5 = trimName.replace(<span class="jxr_string">" const"</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L425" href="#L425">425</a>     trimName = _replace_5;
<a class="jxr_linenumber" name="L426" href="#L426">426</a>     String _replace_6 = trimName.replace(<span class="jxr_string">"volatile"</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L427" href="#L427">427</a>     trimName = _replace_6;
<a class="jxr_linenumber" name="L428" href="#L428">428</a>     String _replace_7 = trimName.replace(<span class="jxr_string">" volatile"</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L429" href="#L429">429</a>     trimName = _replace_7;
<a class="jxr_linenumber" name="L430" href="#L430">430</a>     String _trim = trimName.trim();
<a class="jxr_linenumber" name="L431" href="#L431">431</a>     trimName = _trim;
<a class="jxr_linenumber" name="L432" href="#L432">432</a>     <strong class="jxr_keyword">return</strong> trimName;
<a class="jxr_linenumber" name="L433" href="#L433">433</a>   }
<a class="jxr_linenumber" name="L434" href="#L434">434</a>   
<a class="jxr_linenumber" name="L435" href="#L435">435</a>   <strong class="jxr_keyword">public</strong> List&lt;ICElement&gt; getAllIStructures(<strong class="jxr_keyword">final</strong> IParent parent, <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">boolean</strong> allIncludes, <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">boolean</strong> lookNestedTypes, <strong class="jxr_keyword">final</strong> ICProject project) {
<a class="jxr_linenumber" name="L436" href="#L436">436</a>     <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L437" href="#L437">437</a>       List&lt;ICElement&gt; ret = <strong class="jxr_keyword">new</strong> UniqueEList&lt;ICElement&gt;();
<a class="jxr_linenumber" name="L438" href="#L438">438</a>       ICElement[] childrend = parent.getChildren();
<a class="jxr_linenumber" name="L439" href="#L439">439</a>       <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; (i &lt; childrend.length); i++) {
<a class="jxr_linenumber" name="L440" href="#L440">440</a>         {
<a class="jxr_linenumber" name="L441" href="#L441">441</a>           ICElement child = childrend[i];
<a class="jxr_linenumber" name="L442" href="#L442">442</a>           <strong class="jxr_keyword">boolean</strong> _matched = false;
<a class="jxr_linenumber" name="L443" href="#L443">443</a>           <strong class="jxr_keyword">if</strong> (!_matched) {
<a class="jxr_linenumber" name="L444" href="#L444">444</a>             <strong class="jxr_keyword">if</strong> ((child instanceof IStructure)) {
<a class="jxr_linenumber" name="L445" href="#L445">445</a>               _matched=<strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L446" href="#L446">446</a>               ret.add(((IStructure) child));
<a class="jxr_linenumber" name="L447" href="#L447">447</a>               <strong class="jxr_keyword">if</strong> (lookNestedTypes) {
<a class="jxr_linenumber" name="L448" href="#L448">448</a>                 List&lt;ICElement&gt; _allIStructures = <strong class="jxr_keyword">this</strong>.getAllIStructures(((IStructure) child), allIncludes, lookNestedTypes, project);
<a class="jxr_linenumber" name="L449" href="#L449">449</a>                 ret.addAll(_allIStructures);
<a class="jxr_linenumber" name="L450" href="#L450">450</a>               }
<a class="jxr_linenumber" name="L451" href="#L451">451</a>             }
<a class="jxr_linenumber" name="L452" href="#L452">452</a>           }
<a class="jxr_linenumber" name="L453" href="#L453">453</a>           <strong class="jxr_keyword">if</strong> (!_matched) {
<a class="jxr_linenumber" name="L454" href="#L454">454</a>             <strong class="jxr_keyword">if</strong> ((child instanceof IEnumeration)) {
<a class="jxr_linenumber" name="L455" href="#L455">455</a>               _matched=<strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L456" href="#L456">456</a>               ret.add(((IEnumeration) child));
<a class="jxr_linenumber" name="L457" href="#L457">457</a>             }
<a class="jxr_linenumber" name="L458" href="#L458">458</a>           }
<a class="jxr_linenumber" name="L459" href="#L459">459</a>           <strong class="jxr_keyword">if</strong> (!_matched) {
<a class="jxr_linenumber" name="L460" href="#L460">460</a>             <strong class="jxr_keyword">if</strong> ((child instanceof IParent)) {
<a class="jxr_linenumber" name="L461" href="#L461">461</a>               _matched=<strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L462" href="#L462">462</a>               List&lt;ICElement&gt; _allIStructures_1 = <strong class="jxr_keyword">this</strong>.getAllIStructures(((IParent) child), allIncludes, lookNestedTypes, project);
<a class="jxr_linenumber" name="L463" href="#L463">463</a>               ret.addAll(_allIStructures_1);
<a class="jxr_linenumber" name="L464" href="#L464">464</a>             }
<a class="jxr_linenumber" name="L465" href="#L465">465</a>           }
<a class="jxr_linenumber" name="L466" href="#L466">466</a>           <strong class="jxr_keyword">if</strong> (!_matched) {
<a class="jxr_linenumber" name="L467" href="#L467">467</a>             <strong class="jxr_keyword">if</strong> ((child instanceof IInclude)) {
<a class="jxr_linenumber" name="L468" href="#L468">468</a>               _matched=<strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L469" href="#L469">469</a>               <strong class="jxr_keyword">if</strong> (allIncludes) {
<a class="jxr_linenumber" name="L470" href="#L470">470</a>                 ITranslationUnit unit = <strong class="jxr_keyword">this</strong>.getTranslationUnitFromInclude(((IInclude) child), project);
<a class="jxr_linenumber" name="L471" href="#L471">471</a>                 <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(unit, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L472" href="#L472">472</a>                 <strong class="jxr_keyword">if</strong> (_notEquals) {
<a class="jxr_linenumber" name="L473" href="#L473">473</a>                   List&lt;ICElement&gt; _allIStructures_2 = <strong class="jxr_keyword">this</strong>.getAllIStructures(unit, allIncludes, lookNestedTypes, project);
<a class="jxr_linenumber" name="L474" href="#L474">474</a>                   ret.addAll(_allIStructures_2);
<a class="jxr_linenumber" name="L475" href="#L475">475</a>                 }
<a class="jxr_linenumber" name="L476" href="#L476">476</a>               }
<a class="jxr_linenumber" name="L477" href="#L477">477</a>             }
<a class="jxr_linenumber" name="L478" href="#L478">478</a>           }
<a class="jxr_linenumber" name="L479" href="#L479">479</a>           <strong class="jxr_keyword">if</strong> (!_matched) {
<a class="jxr_linenumber" name="L480" href="#L480">480</a>             <strong class="jxr_keyword">if</strong> ((child instanceof ITypeDef)) {
<a class="jxr_linenumber" name="L481" href="#L481">481</a>               _matched=<strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L482" href="#L482">482</a>               ret.add(child);
<a class="jxr_linenumber" name="L483" href="#L483">483</a>             }
<a class="jxr_linenumber" name="L484" href="#L484">484</a>           }
<a class="jxr_linenumber" name="L485" href="#L485">485</a>           <strong class="jxr_keyword">if</strong> (!_matched) {
<a class="jxr_linenumber" name="L486" href="#L486">486</a>             <strong class="jxr_keyword">if</strong> ((child instanceof IStructureDeclaration)) {
<a class="jxr_linenumber" name="L487" href="#L487">487</a>               _matched=<strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L488" href="#L488">488</a>               ret.add(child);
<a class="jxr_linenumber" name="L489" href="#L489">489</a>             }
<a class="jxr_linenumber" name="L490" href="#L490">490</a>           }
<a class="jxr_linenumber" name="L491" href="#L491">491</a>         }
<a class="jxr_linenumber" name="L492" href="#L492">492</a>       }
<a class="jxr_linenumber" name="L493" href="#L493">493</a>       <strong class="jxr_keyword">return</strong> ret;
<a class="jxr_linenumber" name="L494" href="#L494">494</a>     } <strong class="jxr_keyword">catch</strong> (Throwable _e) {
<a class="jxr_linenumber" name="L495" href="#L495">495</a>       <strong class="jxr_keyword">throw</strong> Exceptions.sneakyThrow(_e);
<a class="jxr_linenumber" name="L496" href="#L496">496</a>     }
<a class="jxr_linenumber" name="L497" href="#L497">497</a>   }
<a class="jxr_linenumber" name="L498" href="#L498">498</a>   
<a class="jxr_linenumber" name="L499" href="#L499">499</a>   <strong class="jxr_keyword">public</strong> ITranslationUnit getTranslationUnitFromInclude(<strong class="jxr_keyword">final</strong> IInclude include, <strong class="jxr_keyword">final</strong> ICProject project) {
<a class="jxr_linenumber" name="L500" href="#L500">500</a>     String _fullFileName = include.getFullFileName();
<a class="jxr_linenumber" name="L501" href="#L501">501</a>     String _elementName = project.getElementName();
<a class="jxr_linenumber" name="L502" href="#L502">502</a>     <strong class="jxr_keyword">boolean</strong> _contains = _fullFileName.contains(_elementName);
<a class="jxr_linenumber" name="L503" href="#L503">503</a>     <strong class="jxr_keyword">boolean</strong> _not = (!_contains);
<a class="jxr_linenumber" name="L504" href="#L504">504</a>     <strong class="jxr_keyword">if</strong> (_not) {
<a class="jxr_linenumber" name="L505" href="#L505">505</a>       <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L506" href="#L506">506</a>     }
<a class="jxr_linenumber" name="L507" href="#L507">507</a>     ITranslationUnit ret = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L508" href="#L508">508</a>     String _fullFileName_1 = include.getFullFileName();
<a class="jxr_linenumber" name="L509" href="#L509">509</a>     String _elementName_1 = project.getElementName();
<a class="jxr_linenumber" name="L510" href="#L510">510</a>     String[] _split = _fullFileName_1.split(_elementName_1);
<a class="jxr_linenumber" name="L511" href="#L511">511</a>     String fileIncludePath = IterableExtensions.&lt;String&gt;last(((Iterable&lt;String&gt;)Conversions.doWrapArray(_split)));
<a class="jxr_linenumber" name="L512" href="#L512">512</a>     IProject _project = project.getProject();
<a class="jxr_linenumber" name="L513" href="#L513">513</a>     IFile file = _project.getFile(fileIncludePath);
<a class="jxr_linenumber" name="L514" href="#L514">514</a>     <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(file, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L515" href="#L515">515</a>     <strong class="jxr_keyword">if</strong> (_notEquals) {
<a class="jxr_linenumber" name="L516" href="#L516">516</a>       ITranslationUnit unit = CoreModelUtil.findTranslationUnit(file);
<a class="jxr_linenumber" name="L517" href="#L517">517</a>       <strong class="jxr_keyword">boolean</strong> _equals = Objects.equal(unit, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L518" href="#L518">518</a>       <strong class="jxr_keyword">if</strong> (_equals) {
<a class="jxr_linenumber" name="L519" href="#L519">519</a>         CoreModel _<strong class="jxr_keyword">default</strong> = CoreModel.getDefault();
<a class="jxr_linenumber" name="L520" href="#L520">520</a>         IPath _location = file.getLocation();
<a class="jxr_linenumber" name="L521" href="#L521">521</a>         ITranslationUnit _createTranslationUnitFrom = _<strong class="jxr_keyword">default</strong>.createTranslationUnitFrom(project, _location);
<a class="jxr_linenumber" name="L522" href="#L522">522</a>         unit = _createTranslationUnitFrom;
<a class="jxr_linenumber" name="L523" href="#L523">523</a>       }
<a class="jxr_linenumber" name="L524" href="#L524">524</a>       ret = unit;
<a class="jxr_linenumber" name="L525" href="#L525">525</a>     }
<a class="jxr_linenumber" name="L526" href="#L526">526</a>     <strong class="jxr_keyword">return</strong> ret;
<a class="jxr_linenumber" name="L527" href="#L527">527</a>   }
<a class="jxr_linenumber" name="L528" href="#L528">528</a>   
<a class="jxr_linenumber" name="L529" href="#L529">529</a>   <strong class="jxr_keyword">public</strong> ITranslationUnit getTranslationUnitFromElement(<strong class="jxr_keyword">final</strong> ICElement element) {
<a class="jxr_linenumber" name="L530" href="#L530">530</a>     ICElement owner = element.getParent();
<a class="jxr_linenumber" name="L531" href="#L531">531</a>     <strong class="jxr_keyword">while</strong> (((!Objects.equal(owner, <strong class="jxr_keyword">null</strong>)) &amp;&amp; (!(owner instanceof ITranslationUnit)))) {
<a class="jxr_linenumber" name="L532" href="#L532">532</a>       ICElement _parent = owner.getParent();
<a class="jxr_linenumber" name="L533" href="#L533">533</a>       owner = _parent;
<a class="jxr_linenumber" name="L534" href="#L534">534</a>     }
<a class="jxr_linenumber" name="L535" href="#L535">535</a>     <strong class="jxr_keyword">return</strong> ((ITranslationUnit) owner);
<a class="jxr_linenumber" name="L536" href="#L536">536</a>   }
<a class="jxr_linenumber" name="L537" href="#L537">537</a>   
<a class="jxr_linenumber" name="L538" href="#L538">538</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> isSatisfyNamespace(<strong class="jxr_keyword">final</strong> List&lt;String&gt; iUsings, <strong class="jxr_keyword">final</strong> ICElement istructure) {
<a class="jxr_linenumber" name="L539" href="#L539">539</a>     <strong class="jxr_keyword">boolean</strong> _and = false;
<a class="jxr_linenumber" name="L540" href="#L540">540</a>     ICElement _parent = istructure.getParent();
<a class="jxr_linenumber" name="L541" href="#L541">541</a>     <strong class="jxr_keyword">boolean</strong> _not = (!(_parent instanceof INamespace));
<a class="jxr_linenumber" name="L542" href="#L542">542</a>     <strong class="jxr_keyword">if</strong> (!_not) {
<a class="jxr_linenumber" name="L543" href="#L543">543</a>       _and = false;
<a class="jxr_linenumber" name="L544" href="#L544">544</a>     } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L545" href="#L545">545</a>       ICElement _parent_1 = istructure.getParent();
<a class="jxr_linenumber" name="L546" href="#L546">546</a>       <strong class="jxr_keyword">boolean</strong> _not_1 = (!(_parent_1 instanceof IStructure));
<a class="jxr_linenumber" name="L547" href="#L547">547</a>       _and = _not_1;
<a class="jxr_linenumber" name="L548" href="#L548">548</a>     }
<a class="jxr_linenumber" name="L549" href="#L549">549</a>     <strong class="jxr_keyword">if</strong> (_and) {
<a class="jxr_linenumber" name="L550" href="#L550">550</a>       <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L551" href="#L551">551</a>     }
<a class="jxr_linenumber" name="L552" href="#L552">552</a>     <strong class="jxr_keyword">final</strong> StringBuilder namespaces = <strong class="jxr_keyword">new</strong> StringBuilder();
<a class="jxr_linenumber" name="L553" href="#L553">553</a>     ICElement owner = istructure.getParent();
<a class="jxr_linenumber" name="L554" href="#L554">554</a>     String _elementName = owner.getElementName();
<a class="jxr_linenumber" name="L555" href="#L555">555</a>     namespaces.append(_elementName);
<a class="jxr_linenumber" name="L556" href="#L556">556</a>     <strong class="jxr_keyword">while</strong> (((owner.getParent() instanceof INamespace) || (owner.getParent() instanceof IStructure))) {
<a class="jxr_linenumber" name="L557" href="#L557">557</a>       {
<a class="jxr_linenumber" name="L558" href="#L558">558</a>         ICElement _parent_2 = owner.getParent();
<a class="jxr_linenumber" name="L559" href="#L559">559</a>         String _elementName_1 = ((INamespace) _parent_2).getElementName();
<a class="jxr_linenumber" name="L560" href="#L560">560</a>         String _plus = (_elementName_1 + <span class="jxr_string">"::"</span>);
<a class="jxr_linenumber" name="L561" href="#L561">561</a>         namespaces.insert(0, _plus);
<a class="jxr_linenumber" name="L562" href="#L562">562</a>         ICElement _parent_3 = owner.getParent();
<a class="jxr_linenumber" name="L563" href="#L563">563</a>         owner = _parent_3;
<a class="jxr_linenumber" name="L564" href="#L564">564</a>       }
<a class="jxr_linenumber" name="L565" href="#L565">565</a>     }
<a class="jxr_linenumber" name="L566" href="#L566">566</a>     <strong class="jxr_keyword">final</strong> Function1&lt;String, Boolean&gt; _function = <strong class="jxr_keyword">new</strong> Function1&lt;String, Boolean&gt;() {
<a class="jxr_linenumber" name="L567" href="#L567">567</a>       @Override
<a class="jxr_linenumber" name="L568" href="#L568">568</a>       <strong class="jxr_keyword">public</strong> Boolean apply(<strong class="jxr_keyword">final</strong> String it) {
<a class="jxr_linenumber" name="L569" href="#L569">569</a>         <strong class="jxr_keyword">boolean</strong> _or = false;
<a class="jxr_linenumber" name="L570" href="#L570">570</a>         String _string = namespaces.toString();
<a class="jxr_linenumber" name="L571" href="#L571">571</a>         <strong class="jxr_keyword">boolean</strong> _equals = it.equals(_string);
<a class="jxr_linenumber" name="L572" href="#L572">572</a>         <strong class="jxr_keyword">if</strong> (_equals) {
<a class="jxr_linenumber" name="L573" href="#L573">573</a>           _or = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L574" href="#L574">574</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L575" href="#L575">575</a>           String _string_1 = namespaces.toString();
<a class="jxr_linenumber" name="L576" href="#L576">576</a>           String _trim = _string_1.trim();
<a class="jxr_linenumber" name="L577" href="#L577">577</a>           <strong class="jxr_keyword">boolean</strong> _contains = it.contains(_trim);
<a class="jxr_linenumber" name="L578" href="#L578">578</a>           _or = _contains;
<a class="jxr_linenumber" name="L579" href="#L579">579</a>         }
<a class="jxr_linenumber" name="L580" href="#L580">580</a>         <strong class="jxr_keyword">return</strong> Boolean.valueOf(_or);
<a class="jxr_linenumber" name="L581" href="#L581">581</a>       }
<a class="jxr_linenumber" name="L582" href="#L582">582</a>     };
<a class="jxr_linenumber" name="L583" href="#L583">583</a>     Iterable&lt;String&gt; _filter = IterableExtensions.&lt;String&gt;filter(iUsings, _function);
<a class="jxr_linenumber" name="L584" href="#L584">584</a>     <strong class="jxr_keyword">boolean</strong> _isEmpty = IterableExtensions.isEmpty(_filter);
<a class="jxr_linenumber" name="L585" href="#L585">585</a>     <strong class="jxr_keyword">return</strong> (!_isEmpty);
<a class="jxr_linenumber" name="L586" href="#L586">586</a>   }
<a class="jxr_linenumber" name="L587" href="#L587">587</a>   
<a class="jxr_linenumber" name="L588" href="#L588">588</a>   <strong class="jxr_keyword">public</strong> List&lt;String&gt; getContextNamespaces(<strong class="jxr_keyword">final</strong> ICElement element) {
<a class="jxr_linenumber" name="L589" href="#L589">589</a>     List&lt;String&gt; ret = <strong class="jxr_keyword">new</strong> UniqueEList&lt;String&gt;();
<a class="jxr_linenumber" name="L590" href="#L590">590</a>     ICElement owner = element.getParent();
<a class="jxr_linenumber" name="L591" href="#L591">591</a>     <strong class="jxr_keyword">while</strong> ((!Objects.equal(owner, <strong class="jxr_keyword">null</strong>))) {
<a class="jxr_linenumber" name="L592" href="#L592">592</a>       {
<a class="jxr_linenumber" name="L593" href="#L593">593</a>         <strong class="jxr_keyword">boolean</strong> _or = false;
<a class="jxr_linenumber" name="L594" href="#L594">594</a>         <strong class="jxr_keyword">if</strong> (((owner instanceof INamespace) || (owner instanceof IStructure))) {
<a class="jxr_linenumber" name="L595" href="#L595">595</a>           _or = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L596" href="#L596">596</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L597" href="#L597">597</a>           _or = (owner instanceof ICContainer);
<a class="jxr_linenumber" name="L598" href="#L598">598</a>         }
<a class="jxr_linenumber" name="L599" href="#L599">599</a>         <strong class="jxr_keyword">if</strong> (_or) {
<a class="jxr_linenumber" name="L600" href="#L600">600</a>           String _elementName = owner.getElementName();
<a class="jxr_linenumber" name="L601" href="#L601">601</a>           ret.add(_elementName);
<a class="jxr_linenumber" name="L602" href="#L602">602</a>           <strong class="jxr_keyword">final</strong> List&lt;String&gt; _converted_ret = (List&lt;String&gt;)ret;
<a class="jxr_linenumber" name="L603" href="#L603">603</a>           <strong class="jxr_keyword">int</strong> _length = ((Object[])Conversions.unwrapArray(_converted_ret, Object.<strong class="jxr_keyword">class</strong>)).length;
<a class="jxr_linenumber" name="L604" href="#L604">604</a>           <strong class="jxr_keyword">boolean</strong> _greaterThan = (_length &gt; 1);
<a class="jxr_linenumber" name="L605" href="#L605">605</a>           <strong class="jxr_keyword">if</strong> (_greaterThan) {
<a class="jxr_linenumber" name="L606" href="#L606">606</a>             String n = IterableExtensions.&lt;String&gt;head(ret);
<a class="jxr_linenumber" name="L607" href="#L607">607</a>             <strong class="jxr_keyword">final</strong> List&lt;String&gt; _converted_ret_1 = (List&lt;String&gt;)ret;
<a class="jxr_linenumber" name="L608" href="#L608">608</a>             <strong class="jxr_keyword">int</strong> len = ((Object[])Conversions.unwrapArray(_converted_ret_1, Object.<strong class="jxr_keyword">class</strong>)).length;
<a class="jxr_linenumber" name="L609" href="#L609">609</a>             <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 1; (i &lt; len); i++) {
<a class="jxr_linenumber" name="L610" href="#L610">610</a>               String _get = ret.get(i);
<a class="jxr_linenumber" name="L611" href="#L611">611</a>               <strong class="jxr_keyword">boolean</strong> _contains = _get.contains(<span class="jxr_string">"::"</span>);
<a class="jxr_linenumber" name="L612" href="#L612">612</a>               <strong class="jxr_keyword">boolean</strong> _not = (!_contains);
<a class="jxr_linenumber" name="L613" href="#L613">613</a>               <strong class="jxr_keyword">if</strong> (_not) {
<a class="jxr_linenumber" name="L614" href="#L614">614</a>                 String _get_1 = ret.get(i);
<a class="jxr_linenumber" name="L615" href="#L615">615</a>                 String _plus = (_get_1 + <span class="jxr_string">"::"</span>);
<a class="jxr_linenumber" name="L616" href="#L616">616</a>                 String _plus_1 = (_plus + n);
<a class="jxr_linenumber" name="L617" href="#L617">617</a>                 n = _plus_1;
<a class="jxr_linenumber" name="L618" href="#L618">618</a>               }
<a class="jxr_linenumber" name="L619" href="#L619">619</a>             }
<a class="jxr_linenumber" name="L620" href="#L620">620</a>             ret.add(n);
<a class="jxr_linenumber" name="L621" href="#L621">621</a>           }
<a class="jxr_linenumber" name="L622" href="#L622">622</a>         }
<a class="jxr_linenumber" name="L623" href="#L623">623</a>         ICElement _parent = owner.getParent();
<a class="jxr_linenumber" name="L624" href="#L624">624</a>         owner = _parent;
<a class="jxr_linenumber" name="L625" href="#L625">625</a>       }
<a class="jxr_linenumber" name="L626" href="#L626">626</a>     }
<a class="jxr_linenumber" name="L627" href="#L627">627</a>     <strong class="jxr_keyword">return</strong> ret;
<a class="jxr_linenumber" name="L628" href="#L628">628</a>   }
<a class="jxr_linenumber" name="L629" href="#L629">629</a>   
<a class="jxr_linenumber" name="L630" href="#L630">630</a>   <strong class="jxr_keyword">public</strong> org.eclipse.uml2.uml.Package getNearestPackage(<strong class="jxr_keyword">final</strong> Element element) {
<a class="jxr_linenumber" name="L631" href="#L631">631</a>     <strong class="jxr_keyword">return</strong> element.getNearestPackage();
<a class="jxr_linenumber" name="L632" href="#L632">632</a>   }
<a class="jxr_linenumber" name="L633" href="#L633">633</a>   
<a class="jxr_linenumber" name="L634" href="#L634">634</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> unapplyAllStereotypes(<strong class="jxr_keyword">final</strong> Element element) {
<a class="jxr_linenumber" name="L635" href="#L635">635</a>     <strong class="jxr_keyword">final</strong> EList&lt;EObject&gt; stereotypeAppList = element.getStereotypeApplications();
<a class="jxr_linenumber" name="L636" href="#L636">636</a>     <strong class="jxr_keyword">final</strong> Consumer&lt;EObject&gt; _function = <strong class="jxr_keyword">new</strong> Consumer&lt;EObject&gt;() {
<a class="jxr_linenumber" name="L637" href="#L637">637</a>       @Override
<a class="jxr_linenumber" name="L638" href="#L638">638</a>       <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> accept(<strong class="jxr_keyword">final</strong> EObject it) {
<a class="jxr_linenumber" name="L639" href="#L639">639</a>         <strong class="jxr_keyword">final</strong> Stereotype stereotype = UMLUtil.getStereotype(it);
<a class="jxr_linenumber" name="L640" href="#L640">640</a>         element.unapplyStereotype(stereotype);
<a class="jxr_linenumber" name="L641" href="#L641">641</a>       }
<a class="jxr_linenumber" name="L642" href="#L642">642</a>     };
<a class="jxr_linenumber" name="L643" href="#L643">643</a>     stereotypeAppList.forEach(_function);
<a class="jxr_linenumber" name="L644" href="#L644">644</a>   }
<a class="jxr_linenumber" name="L645" href="#L645">645</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
